package cn.iocoder.yudao.module.mes.service.criticalcomponent;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.mes.controller.admin.criticalcomponent.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.criticalcomponent.CriticalComponentDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 设备关键件 Service 接口
 *
 * @author 内蒙必硕
 */
public interface CriticalComponentService {

    /**
     * 创建设备关键件
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCriticalComponent(@Valid CriticalComponentSaveReqVO createReqVO);

    /**
     * 更新设备关键件
     *
     * @param updateReqVO 更新信息
     */
    void updateCriticalComponent(@Valid CriticalComponentSaveReqVO updateReqVO);

    /**
     * 删除设备关键件
     *
     * @param id 编号
     */
    void deleteCriticalComponent(List<Long> idList);

    /**
     * 获得设备关键件
     *
     * @param id 编号
     * @return 设备关键件
     */
    CriticalComponentDO getCriticalComponent(Long id);

    /**
     * 获得设备关键件分页
     *
     * @param pageReqVO 分页查询
     * @return 设备关键件分页
     */
    PageResult<CriticalComponentDO> getCriticalComponentPage(CriticalComponentPageReqVO pageReqVO);

    List<CriticalComponentDO> getCriticalComponentList();

    List<CriticalComponentExcelVO> exportDeviceComponent(Long id);

    /**
     * 导入设备关键件列表
     */
    CriticalComponentImportRespVO importCriticalComponentList(List<CriticalComponentImportExcelVO> importComponents, boolean isUpdateSupport);

}